package com.example.haiwei_mom.wms.raw;

import androidx.databinding.DataBindingUtil;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.RawReturnVo;
import com.example.haiwei_mom.data.RawReturnSubmitBeen;
import com.example.haiwei_mom.databinding.ActivityRawReturnBinding;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.math.BigDecimal;

import okhttp3.RequestBody;

public class RawReturnActivity extends BaseActivity implements View.OnFocusChangeListener {
    private RawReturnVo params;
    ActivityRawReturnBinding binding;

    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        binding = DataBindingUtil.setContentView(this, R.layout.activity_raw_return);
        binding.rawReturnCode.setOnFocusChangeListener(this);
        binding.rawReturnCode.setOnTouchListener((v, event) -> {
            final int DRAWABLE_RIGHT = 2;
            if (event.getAction() == MotionEvent.ACTION_UP) {
                // 获取触摸的位置
                int x = (int) event.getX();
                // 获取图标的边界
                int drawableRightWidth = binding.rawReturnCode.getCompoundDrawables()[DRAWABLE_RIGHT].getBounds().width();
                int drawableRightStart = (int) (binding.rawReturnCode.getWidth() - binding.rawReturnCode.getPaddingRight() - drawableRightWidth);
                // 判断是否点击了右侧图标
                if (x >= drawableRightStart && x <= (binding.rawReturnCode.getWidth() - binding.rawReturnCode.getPaddingRight())) {
                    selectCode();
                    return true;
                }
            }
            return false;
        });
        params = new RawReturnVo();
        binding.setVo(params);
    }

    private void selectCode() {
        OkGo.<MyResult>post(url + "/wms/pda/raw/returnSelectCode")
                .params("code", params.getBatchCode())
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            params = gson.fromJson(body.getDataJson(), RawReturnVo.class);
                            binding.setVo(params);
                            return;
                        }
                        myToastUitls.show(body.getMsg());

                    }
                });
    }

    public void rawReturnSubmit(View view) {
        var planAmount = params.getPlanAmount();
        if (planAmount == null) {
            return;
        }
        var val = Double.parseDouble(planAmount);
        if (val > params.getOutstockQty()) {
            myToastUitls.show("退库数量不能超过原数量");
            return;
        }
        RawReturnSubmitBeen sub = new RawReturnSubmitBeen();
        sub.setMaterialId(params.getMaterialId());
        sub.setBatchCode(params.getBatchCode());
        sub.setPlanAmount(BigDecimal.valueOf(val));
        sub.setPlanLocationCode(params.getLocationCode());
        sub.setMaterialCategories(params.getMaterialCategories());
        sub.setWarehouseId(params.getWarehouseId());
        Log.e("TAG", "rawReturnSubmit:" + params.getOutstockRecordId());
        sub.setOutstockRecordId(params.getOutstockRecordId());
        // 修改出库
        sub.setOutstockRecordId(params.getOutstockRecordId());

        OkGo.<MyResult>post(url + "/wms/pda/raw/returnSubmit")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(sub)))
                .execute(new MyRecultCall(dialog, context) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            finish();
                            // return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    private EditText focusedView;

    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);
        Log.e("TAG", "getScannerData:" + data);
        if (focusedView!=null){
            EditText editText = focusedView;
            // 将接收到的数据添加到 EditText 中
            editText.append(data);
            if (editText==binding.rawReturnCode){
                selectCode();
            }
        }



    }

    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        if (hasFocus) {
            Log.e("TAG", "onFocusChange:" + v.getId());
            focusedView = (EditText) v;
        }

    }
}